class com.bourre.log.Logger
{
   var _oEB;
   var _oLevel;
   static var _oI;
   function Logger()
   {
      this._oEB = new com.bourre.events.EventBroadcaster(this);
      this._oLevel = com.bourre.log.LogLevel.DEBUG;
   }
   static function getInstance()
   {
      return com.bourre.log.Logger._oI == undefined ? com.bourre.log.Logger._init() : com.bourre.log.Logger._oI;
   }
   static function LOG(o, oLevel, channel)
   {
      com.bourre.log.Logger.getInstance().log(o,oLevel,channel);
   }
   static function SETLEVEL(oLevel)
   {
      com.bourre.log.Logger.getInstance()._oLevel = oLevel;
   }
   static function GETLEVEL()
   {
      return com.bourre.log.Logger.getInstance()._oLevel;
   }
   function addLogListener(listener, channel)
   {
      if(!channel)
      {
         this._oEB.addListener(listener,listener.onLog);
      }
      else
      {
         this._oEB.addEventListener(channel,listener,listener.onLog);
      }
   }
   function removeLogListener(listener, channel)
   {
      if(!channel)
      {
         this._oEB.removeListener(listener);
      }
      else
      {
         this._oEB.removeEventListener(channel,listener);
      }
   }
   function log(logContent, oLevel, channel)
   {
      if(oLevel == undefined)
      {
         oLevel = com.bourre.log.LogLevel.DEBUG;
      }
      if(oLevel.isEnabled())
      {
         this._oEB.broadcastEvent(new com.bourre.log.LogEvent(oLevel,logContent,channel));
      }
   }
   function toString()
   {
      return com.bourre.log.PixlibStringifier.stringify(this);
   }
   static function _init()
   {
      com.bourre.log.Logger._oI = new com.bourre.log.Logger();
      return com.bourre.log.Logger._oI;
   }
}
