class sandy.core.Object3D extends sandy.core.group.Leaf
{
   var aPoints;
   var _aFaces;
   var _aUv;
   var enableBackFaceCulling;
   var _bEv;
   var _needRedraw;
   var _s;
   var _sb;
   static var _DEFAUT_SKIN = new sandy.skin.SimpleLineSkin();
   function Object3D()
   {
      super();
      this.aPoints = new Array();
      this._aFaces = new Array();
      this._aUv = new Array();
      this.enableBackFaceCulling = true;
      this._bEv = false;
      this._needRedraw = false;
      this.setSkin(sandy.core.Object3D.DEFAULT_SKIN,true);
      this.setBackSkin(sandy.core.Object3D.DEFAULT_SKIN,true);
   }
   static function get DEFAULT_SKIN()
   {
      return sandy.core.Object3D._DEFAUT_SKIN;
   }
   function toString(Void)
   {
      return "sandy.core.Object3D";
   }
   function getSkin(Void)
   {
      return this._s;
   }
   function getPosition(Void)
   {
      var _loc2_ = this.aPoints[0];
      return new sandy.core.data.Vector(_loc2_.tx - _loc2_.x,_loc2_.ty - _loc2_.y,_loc2_.tz - _loc2_.z);
   }
   function getBackSkin(Void)
   {
      return this._sb;
   }
   function setSkin(s, bOverWrite)
   {
      this._s.removeEventListener(sandy.events.SkinEvent.onUpdateEVENT,this);
      bOverWrite = bOverWrite != undefined ? bOverWrite : false;
      var _loc4_ = this._aFaces;
      var _loc3_ = _loc4_.length;
      while((_loc3_ = _loc3_ - 1) > -1)
      {
         var _loc2_ = _loc4_[_loc3_];
         if(bOverWrite || _loc2_.getSkin() == this._s)
         {
            _loc2_.setSkin(s);
         }
      }
      this._s = s;
      this._s.addEventListener(sandy.events.SkinEvent.onUpdateEVENT,this,this.__onSkinUpdated);
      return true;
   }
   function setBackSkin(s, bOverWrite)
   {
      this._s.removeEventListener(sandy.events.SkinEvent.onUpdateEVENT,this);
      bOverWrite = bOverWrite != undefined ? bOverWrite : false;
      var _loc4_ = this._aFaces;
      var _loc3_ = _loc4_.length;
      while((_loc3_ = _loc3_ - 1) > -1)
      {
         var _loc2_ = _loc4_[_loc3_];
         if(bOverWrite || _loc2_.getBackSkin() == this._sb)
         {
            _loc2_.setBackSkin(s);
         }
      }
      this._sb = s;
      this._s.addEventListener(sandy.events.SkinEvent.onUpdateEVENT,this,this.__onSkinUpdated);
      return true;
   }
   function enableEvents(b)
   {
      this._bEv = b;
      var _loc2_ = undefined;
      for(_loc2_ in this._aFaces)
      {
         sandy.core.face.Face(this._aFaces[_loc2_]).enableEvents(b);
      }
   }
   function swapCulling(Void)
   {
      var _loc2_ = undefined;
      for(_loc2_ in this._aFaces)
      {
         sandy.core.face.Face(this._aFaces[_loc2_]).swapCulling();
      }
   }
   function addUVCoordinate(x, y)
   {
      this.setModified(true);
      var _loc2_ = new sandy.core.data.UVCoord(x,y);
      this._aUv.push(_loc2_);
      return _loc2_;
   }
   function addPoint(px, py, pz)
   {
      this.setModified(true);
      return this.aPoints.push(new sandy.core.data.Vertex(px,py,pz));
   }
   function render(Void)
   {
      var _loc5_ = undefined;
      var _loc8_ = undefined;
      var _loc3_ = this._aFaces;
      var _loc4_ = undefined;
      var _loc2_ = undefined;
      for(_loc4_ in _loc3_)
      {
         _loc2_ = _loc3_[_loc4_];
         _loc5_ = _loc2_.getZAverage();
         if(_loc2_.getMinDepth() > 100)
         {
            if(_loc2_.isVisible() || !this.enableBackFaceCulling)
            {
               sandy.core.buffer.ZBuffer.push({face:_loc2_,depth:_loc5_});
            }
         }
      }
      this._needRedraw = false;
   }
   function refresh(Void)
   {
      var _loc3_ = undefined;
      var _loc2_ = this._aFaces;
      for(_loc3_ in _loc2_)
      {
         _loc2_[_loc3_].refresh();
      }
      this._needRedraw = false;
   }
   function getBounds(Void)
   {
      return sandy.core.data.BBox.create(this);
   }
   function addFace(f)
   {
      f.setSkin(this._s);
      f.setBackSkin(this._sb);
      this._aFaces.push(f);
      f.addEventListener(sandy.events.ObjectEvent.onPressEVENT,this,this.__onPressed);
      f.addEventListener(sandy.events.ObjectEvent.onRollOverEVENT,this,this.__onRollOver);
      f.addEventListener(sandy.events.ObjectEvent.onRollOutEVENT,this,this.__onRollOut);
      this.setModified(true);
   }
   function getFaces()
   {
      return this._aFaces;
   }
   function needRefresh(Void)
   {
      return this._needRedraw;
   }
   function __onPressed(e)
   {
      this.broadcastEvent(new sandy.events.ObjectEvent(sandy.events.ObjectEvent.onPressEVENT,this));
   }
   function __onRollOver(e)
   {
      this.broadcastEvent(new sandy.events.ObjectEvent(sandy.events.ObjectEvent.onRollOverEVENT,this));
   }
   function __onRollOut(e)
   {
      this.broadcastEvent(new sandy.events.ObjectEvent(sandy.events.ObjectEvent.onRollOutEVENT,this));
   }
   function __onSkinUpdated(e)
   {
      this._needRedraw = true;
   }
}
