class sandy.core.World3D
{
   var _eRender;
   var _eStart;
   var _oEB;
   var _light;
   var _isRunning;
   var _aCams;
   var _oRoot;
   var _mProj;
   var _oCam;
   var _bGlbCache;
   var _aObjects;
   var _aMatrix;
   var _aCache;
   static var _inst;
   static var onRenderEVENT = new com.bourre.events.EventType("onRender");
   static var onStartEVENT = new com.bourre.events.EventType("onStart");
   static var onStopEVENT = new com.bourre.events.EventType("onStop");
   static var onLightUpdatedEVENT = new com.bourre.events.EventType("onLightUpdated");
   static var onInitCacheEVENT = new com.bourre.events.EventType("onInitCache");
   function World3D()
   {
      this._eRender = new com.bourre.events.BasicEvent(sandy.core.World3D.onRenderEVENT);
      this._eStart = new com.bourre.events.BasicEvent(sandy.core.World3D.onStartEVENT);
      this._oEB = new com.bourre.events.EventBroadcaster(this);
      this._light = new sandy.core.light.Light3D(new sandy.core.data.Vector(0,0,1),50);
      this._isRunning = false;
      this._aCams = [];
      com.bourre.transitions.FPSBeacon.getInstance().addFrameListener(new com.bourre.commands.Delegate(this,this.__onEnterFrame));
   }
   function addEventListener(t, o)
   {
      this._oEB.addEventListener.apply(this._oEB,arguments);
   }
   function removeEventListener(e, oL)
   {
      this._oEB.removeEventListener(e,oL);
   }
   static function getInstance()
   {
      if(sandy.core.World3D._inst === undefined)
      {
         sandy.core.World3D._inst = new sandy.core.World3D();
      }
      return sandy.core.World3D._inst;
   }
   function addCamera(cam)
   {
      return this._aCams.push(cam) - 1;
   }
   function getCameraList(Void)
   {
      return this._aCams;
   }
   function getCamera(id)
   {
      if(!id || id < 0 || id >= this._aCams.length)
      {
         id = 0;
      }
      return this._aCams[id];
   }
   function setLight(l)
   {
      this._oEB.broadcastEvent(new com.bourre.events.BasicEvent(sandy.core.World3D.onLightUpdatedEVENT));
      this._light = l;
   }
   function getLight(Void)
   {
      return this._light;
   }
   function setRootGroup(objGroup)
   {
      this._oRoot = objGroup;
   }
   function getRootGroup(Void)
   {
      return this._oRoot;
   }
   function render(Void)
   {
      if(this._isRunning == false)
      {
         this._isRunning = true;
         this._oEB.broadcastEvent(this._eStart);
         com.bourre.transitions.FPSBeacon.getInstance().start();
      }
   }
   function stop(Void)
   {
      com.bourre.transitions.FPSBeacon.getInstance().stop();
      this._isRunning = false;
   }
   function __onEnterFrame(Void)
   {
      this._oEB.broadcastEvent(this._eRender);
      this.__render();
   }
   function getCurrentProjectionMatrix(Void)
   {
      return this._mProj;
   }
   function getCurrentCamera(Void)
   {
      return this._oCam;
   }
   function __render(Void)
   {
      var _loc10_ = undefined;
      var _loc33_ = undefined;
      var _loc7_ = undefined;
      var _loc6_ = undefined;
      var _loc5_ = undefined;
      var _loc4_ = undefined;
      var _loc30_ = undefined;
      var _loc29_ = undefined;
      var _loc34_ = undefined;
      var _loc35_ = undefined;
      var _loc14_ = undefined;
      var _loc12_ = undefined;
      var _loc22_ = undefined;
      var _loc28_ = undefined;
      var _loc13_ = undefined;
      var _loc23_ = undefined;
      var _loc19_ = undefined;
      var _loc27_ = undefined;
      var _loc24_ = undefined;
      var _loc20_ = undefined;
      var _loc17_ = undefined;
      var _loc26_ = undefined;
      var _loc21_ = undefined;
      var _loc18_ = undefined;
      var _loc16_ = undefined;
      var _loc25_ = undefined;
      var _loc3_ = undefined;
      var _loc9_ = undefined;
      var _loc15_ = undefined;
      var _loc8_ = undefined;
      var _loc2_ = undefined;
      var _loc37_ = undefined;
      var _loc36_ = undefined;
      if(!(_loc35_ = this._aCams.length) || this._oRoot == null)
      {
         return undefined;
      }
      this._bGlbCache = false;
      this._aObjects = [];
      this._aMatrix = [];
      this._aCache = [];
      sandy.core.buffer.MatrixBuffer.init();
      this.__parseTree(this._oRoot,this._oRoot.isModified());
      _loc10_ = _loc34_ = this._aObjects.length;
      while((_loc10_ = _loc10_ - 1) > -1)
      {
         _loc8_ = this._aObjects[_loc10_];
         if(this._aCache[_loc10_] == true)
         {
            _loc3_ = this._aMatrix[_loc10_];
            if(_loc3_)
            {
               _loc9_ = _loc8_.aPoints;
               _loc14_ = _loc3_.n11;
               _loc12_ = _loc3_.n21;
               _loc22_ = _loc3_.n31;
               _loc13_ = _loc3_.n12;
               _loc23_ = _loc3_.n22;
               _loc19_ = _loc3_.n32;
               _loc24_ = _loc3_.n13;
               _loc20_ = _loc3_.n23;
               _loc17_ = _loc3_.n33;
               _loc21_ = _loc3_.n14;
               _loc18_ = _loc3_.n24;
               _loc16_ = _loc3_.n34;
               _loc7_ = _loc9_.length;
               while((_loc7_ = _loc7_ - 1) > -1)
               {
                  _loc2_ = _loc9_[_loc7_];
                  _loc2_.tx = (_loc6_ = _loc2_.x) * _loc14_ + (_loc5_ = _loc2_.y) * _loc13_ + (_loc4_ = _loc2_.z) * _loc24_ + _loc21_;
                  _loc2_.ty = _loc6_ * _loc12_ + _loc5_ * _loc23_ + _loc4_ * _loc20_ + _loc18_;
                  _loc2_.tz = _loc6_ * _loc22_ + _loc5_ * _loc19_ + _loc4_ * _loc17_ + _loc16_;
               }
            }
            else
            {
               _loc9_ = _loc8_.aPoints;
               _loc7_ = _loc9_.length;
               while((_loc7_ = _loc7_ - 1) > -1)
               {
                  _loc2_ = _loc9_[_loc7_];
                  _loc2_.tx = _loc2_.x;
                  _loc2_.ty = _loc2_.y;
                  _loc2_.tz = _loc2_.z;
               }
            }
         }
      }
      _loc33_ = _loc35_;
      while((_loc33_ = _loc33_ - 1) > -1)
      {
         this._oCam = _loc15_ = this._aCams[_loc33_];
         if(this._bGlbCache || _loc15_.isModified())
         {
            _loc15_.compile();
            _loc30_ = _loc15_.getXOffset();
            _loc29_ = _loc15_.getYOffset();
            this._mProj = _loc3_ = _loc15_.m;
            _loc14_ = _loc3_.n11;
            _loc12_ = _loc3_.n21;
            _loc22_ = _loc3_.n31;
            _loc28_ = _loc3_.n41;
            _loc13_ = _loc3_.n12;
            _loc23_ = _loc3_.n22;
            _loc19_ = _loc3_.n32;
            _loc27_ = _loc3_.n42;
            _loc24_ = _loc3_.n13;
            _loc20_ = _loc3_.n23;
            _loc17_ = _loc3_.n33;
            _loc26_ = _loc3_.n43;
            _loc21_ = _loc3_.n14;
            _loc18_ = _loc3_.n24;
            _loc16_ = _loc3_.n34;
            _loc25_ = _loc3_.n44;
            _loc10_ = _loc34_;
            while((_loc10_ = _loc10_ - 1) > -1)
            {
               _loc8_ = sandy.core.Object3D(this._aObjects[_loc10_]);
               _loc9_ = _loc8_.aPoints;
               _loc7_ = _loc9_.length;
               while((_loc7_ = _loc7_ - 1) > -1)
               {
                  _loc2_ = _loc9_[_loc7_];
                  var _loc11_ = 1 / ((_loc6_ = _loc2_.tx) * _loc28_ + (_loc5_ = _loc2_.ty) * _loc27_ + (_loc4_ = _loc2_.tz) * _loc26_ + _loc25_);
                  _loc2_.sx = (_loc2_.wx = _loc6_ * _loc14_ + _loc5_ * _loc13_ + _loc4_ * _loc24_ + _loc21_) * _loc11_ + _loc30_;
                  _loc2_.sy = (_loc2_.wy = _loc6_ * _loc12_ + _loc5_ * _loc23_ + _loc4_ * _loc20_ + _loc18_) * _loc11_ + _loc29_;
                  _loc2_.wz = _loc6_ * _loc22_ + _loc5_ * _loc19_ + _loc4_ * _loc17_ + _loc16_;
               }
               _loc8_.render();
            }
            var _loc32_ = sandy.core.buffer.ZBuffer.sort();
            var _loc31_ = _loc15_.is;
            _loc31_.render(_loc32_);
            sandy.core.buffer.ZBuffer.dispose();
         }
         else
         {
            _loc10_ = _loc34_;
            while((_loc10_ = _loc10_ - 1) > -1)
            {
               _loc8_ = sandy.core.Object3D(this._aObjects[_loc10_]);
               if(_loc8_.needRefresh())
               {
                  _loc8_.refresh();
               }
            }
         }
      }
   }
   function __parseTree(n, cache)
   {
      var _loc4_ = n.getChildList();
      var _loc3_ = n.isModified();
      this._bGlbCache = this._bGlbCache || _loc3_;
      var _loc2_ = _loc4_.length;
      if(!_loc2_)
      {
         this._aObjects.push(n);
         this._aCache.push(cache || _loc3_);
         this._aMatrix.push(sandy.core.buffer.MatrixBuffer.getCurrentMatrix());
      }
      else
      {
         n.render();
         while((_loc2_ = _loc2_ - 1) > -1)
         {
            this.__parseTree(_loc4_[_loc2_],cache || _loc3_);
         }
         n.dispose();
      }
      n.setModified(false);
      return undefined;
   }
}
