class sandy.core.group.Node extends com.bourre.events.EventBroadcaster
{
   var _parent;
   var _aChilds;
   var _id;
   var _modified;
   static var _ID_ = 0;
   function Node()
   {
      super(this);
      this._parent = null;
      this._aChilds = [];
      this._id = sandy.core.group.Node._ID_++;
      this.setModified(true);
   }
   function getId(Void)
   {
      return this._id;
   }
   function isParent(n)
   {
      return this._parent == n && n != undefined;
   }
   function isModified(Void)
   {
      return this._modified;
   }
   function setModified(b)
   {
      this._modified = b;
   }
   function setParent(n)
   {
      if(undefined == n)
      {
         return false;
      }
      this._parent = n;
      this.setModified(true);
      return true;
   }
   function getParent(Void)
   {
      return this._parent;
   }
   function hasParent(Void)
   {
      return undefined != this._parent;
   }
   function addChild(child)
   {
      child.setParent(this);
      this.setModified(true);
      this._aChilds.push(child);
   }
   function getChildList(Void)
   {
      return this._aChilds;
   }
   function getChild(index)
   {
      return this._aChilds[index];
   }
   function removeChild(child)
   {
      if(!child.isParent(this))
      {
         return false;
      }
      var _loc3_ = false;
      var _loc2_ = 0;
      while(_loc2_ < this._aChilds.length && !_loc3_)
      {
         if(this._aChilds[_loc2_] == child)
         {
            this._aChilds.splice(_loc2_,1);
            this.setModified(true);
            _loc3_ = true;
         }
         _loc2_ = _loc2_ + 1;
      }
      return _loc3_;
   }
   function destroy()
   {
      if(this.hasParent())
      {
         this._parent.removeChild(this);
      }
      var _loc2_ = this._aChilds.length;
      while((_loc2_ = _loc2_ - 1) > -1)
      {
         this._aChilds[_loc2_].destroy();
         delete this._aChilds[_loc2_];
      }
      delete this._aChilds;
      this._parent = null;
   }
   function remove()
   {
      var _loc2_ = this._aChilds.length;
      this._parent.removeChild(this,false);
      while((_loc2_ = _loc2_ - 1) > -1)
      {
         this._parent.addChild(this._aChilds[_loc2_],false);
      }
      delete this._aChilds;
      this._parent = null;
      this.setModified(true);
   }
}
