class sandy.core.transform.Transform3D extends com.bourre.events.EventBroadcaster implements sandy.core.transform.ITransform3D
{
   var _m;
   var _type;
   var _bModified;
   static var onUpdateEVENT = new com.bourre.events.EventType("onUpdate");
   function Transform3D(Void)
   {
      super(this);
      this._m = sandy.core.data.Matrix4.createIdentity();
      this._type = sandy.core.transform.TransformType.NONE;
   }
   function rotX(pAngle)
   {
      var _loc2_ = (pAngle + 360) % 360;
      this._m = sandy.math.Matrix4Math.rotationX(_loc2_);
      this._type = sandy.core.transform.TransformType.ROTATION;
      this.__dispatch();
   }
   function rotY(pAngle)
   {
      var _loc2_ = (pAngle + 360) % 360;
      this._m = sandy.math.Matrix4Math.rotationY(_loc2_);
      this._type = sandy.core.transform.TransformType.ROTATION;
      this.__dispatch();
   }
   function rotZ(pAngle)
   {
      var _loc2_ = (pAngle + 360) % 360;
      this._m = sandy.math.Matrix4Math.rotationZ(_loc2_);
      this._type = sandy.core.transform.TransformType.ROTATION;
      this.__dispatch();
   }
   function rot(px, py, pz)
   {
      px = (px + 360) % 360;
      py = (py + 360) % 360;
      pz = (pz + 360) % 360;
      this._m = sandy.math.Matrix4Math.eulerRotation(px,py,pz);
      this._type = sandy.core.transform.TransformType.ROTATION;
      this.__dispatch();
   }
   function rotVector(v)
   {
      this.rot(v.x,v.y,v.z);
      this.__dispatch();
   }
   function rotAxis(pAxis, pAngle)
   {
      var _loc3_ = (pAngle + 360) % 360;
      sandy.math.VectorMath.normalize(pAxis);
      this._m = sandy.math.Matrix4Math.axisRotation(pAxis.x,pAxis.y,pAxis.z,_loc3_);
      this._type = sandy.core.transform.TransformType.ROTATION;
      this.__dispatch();
   }
   function rotAxisWithReference(axis, ref, pAngle)
   {
      var _loc3_ = (pAngle + 360) % 360;
      this._m = sandy.math.Matrix4Math.translation(ref.x,- ref.y,ref.z);
      this._m = sandy.math.Matrix4Math.multiply(this._m,sandy.math.Matrix4Math.axisRotation(axis.x,axis.y,axis.z,_loc3_));
      this._m = sandy.math.Matrix4Math.multiply(this._m,sandy.math.Matrix4Math.translation(- ref.x,ref.y,- ref.z));
      this._type = sandy.core.transform.TransformType.ROTATION;
      this.__dispatch();
   }
   function scaleX(pVal)
   {
      this._m = sandy.math.Matrix4Math.scale(pVal,0,0);
      this._type = sandy.core.transform.TransformType.SCALE;
      this.__dispatch();
   }
   function scaleY(pVal)
   {
      this._m = sandy.math.Matrix4Math.scale(0,pVal,0);
      this._type = sandy.core.transform.TransformType.SCALE;
      this.__dispatch();
   }
   function scaleZ(pVal)
   {
      this._m = sandy.math.Matrix4Math.scale(0,0,pVal);
      this._type = sandy.core.transform.TransformType.SCALE;
      this.__dispatch();
   }
   function scale(px, py, pz)
   {
      this._m = sandy.math.Matrix4Math.scale(px,py,pz);
      this._type = sandy.core.transform.TransformType.SCALE;
      this.__dispatch();
   }
   function scaleVector(v)
   {
      this.scale(v.x,v.y,v.z);
      this.__dispatch();
   }
   function translateX(val)
   {
      this._m = sandy.math.Matrix4Math.translation(val,0,0);
      this._type = sandy.core.transform.TransformType.TRANSLATION;
      this.__dispatch();
   }
   function translateY(val)
   {
      this._m = sandy.math.Matrix4Math.translation(0,val,0);
      this._type = sandy.core.transform.TransformType.TRANSLATION;
      this.__dispatch();
   }
   function translateZ(val)
   {
      this._m = sandy.math.Matrix4Math.translation(0,0,val);
      this._type = sandy.core.transform.TransformType.TRANSLATION;
      this.__dispatch();
   }
   function translate(tx, ty, tz)
   {
      this._m = sandy.math.Matrix4Math.translation(tx,- ty,tz);
      this._type = sandy.core.transform.TransformType.TRANSLATION;
      this.__dispatch();
   }
   function translateVector(v)
   {
      this.translate(v.x,v.y,v.z);
      this.__dispatch();
   }
   function getType(Void)
   {
      return this._type;
   }
   function getMatrix(Void)
   {
      return this._m;
   }
   function combineMatrix(m)
   {
      this._m = sandy.math.Matrix4Math.multiply(this._m,m);
      this._type = sandy.core.transform.TransformType.MIXED;
      this.__dispatch();
   }
   function combineTransform(t)
   {
      this._m = sandy.math.Matrix4Math.multiply(this._m,t.getMatrix());
      this._type = sandy.core.transform.TransformType.MIXED;
      this.__dispatch();
   }
   function __dispatch(Void)
   {
      this.setModified(true);
   }
   function isModified(Void)
   {
      return this._bModified;
   }
   function setModified(b)
   {
      this._bModified = b;
   }
}
